        program read
c-----------------------------------------------------------
c ....  ny=number of years
c ....  ns=number of stations
c ....  ist=starting year of data
c ....  jdy=number of julian days (non leap years only)
c-----------------------------------------------------------
        parameter (ny=NYRS,ns=NSTNS,ist=STYR) ! **** Change this line as needed
        parameter (nm=12,ndm=31,ndy=365)  ! Do not Change this line
c
        real bb(ns,ny,ndy),c(nm,ndm)
        real xlat(ns),xlon(ns)
        integer yr, mn, lyy(ny), ids(nm)
        character*8 stnn(ns)
c
        data ids/31,28,31,30,31,30,31,31,30,31,30,31/
c..
c..****If needed, change following input and output file names  ****
c..
        open(10,file='stations.txt',
     1  form='formatted',status='old')
        open(21,file='formatted_data.txt',
     1  form='formatted',status='unknown')
c
c
c-- Do not change below this line----------------------
c
        iyy=ist-1
        do iy=1,ny
          iyy=iyy+1
          lyy(iy)=iyy
        enddo
c-----begin read------------------------
        do is=1,ns
          read(10,103,err=555) xlat(is),xlon(is),stnn(is)
           print*, is, stnn(is)
        do iy=1,ny
	  ixy1=ist+iy-1	  
        do im=1,nm
         read(10,*,err=555) ixy,imy,(c(im,idm),idm=1,ndm)
	   print*, ixy,ixy1,imy,im
	   if ((ixy1.ne.ixy).or.(imy.ne.im)) then
	    print*, 'In your data ..'
	    print*, 'month or year for the station is out of sequence'
	    print*, stnn(is), ixy, imy
            stop
	   endif
	  do idm=1,ndm
	   if ((c(im,idm).lt.0.0).and.(c(im,idm).ne.-99999.)) then
	    print*, 'there is bad data for ', stnn(is), ixy, imy
            stop
	   endif
	   if (c(im,idm).gt.999.0) then
	    print*, 'there is bad data for ', stnn(is), ixy, imy
            stop
	   endif
	  enddo
        enddo
c
        ic=0
        do im=1,nm
         idyy=ids(im)
        do idm=1,idyy
         ic=ic+1
         bb(is,iy,ic)=c(im,idm)
        enddo
        enddo
c
        enddo
        
c
        enddo
 555    continue
	print*, 'SUCCESS!! - NOW THE DATA IS READY FOR IN CMT'
c
c--begin writing-----------------
        do is=1,ns
        write(21,103) xlat(is),xlon(is),stnn(is)
        write(21,105) (lyy(iy),iy=1,ny)
        do idy=1,ndy
        write(21,333) (bb(is,iy,idy),iy=1,ny)
        enddo
        enddo
c-----------------
 103    format(2f10.2,a8)
 105    format(NYRSi10)
 333    format(NYRSf10.2)
c
        stop
        end
